/*	Applicazione che crea un frame con:
	1) 	colore;
	2)	dimensione del font;
	3)	stile del font;
	4)	messaggio;
	forniti dall'utente mediante JOptionPane
*/

import java.awt.*;
import javax.swing.*;

//Classe pubblica per l'inizializzazione del frame:
public class ApplicazioneInterattiva extends Object
{
	//main:
	public static void main (String[] args)
	{
		int r=0, g=0, b=0, dim;
		String tipo="", stile="", msg;
		//ottengo i dati dall'utente mediante JOptionPane:
		while (r < 0 || r > 255 || g < 0 || g > 255 || b < 0 || b > 255)
		{
			r = Integer.parseInt (JOptionPane.showInputDialog ("Inserisci la componente RED del colore (0-255)"));
			g = Integer.parseInt (JOptionPane.showInputDialog ("Inserisci la componente GREEN del colore (0-255)"));
			b = Integer.parseInt (JOptionPane.showInputDialog ("Inserisci la componente BLUE del colore (0-255)"));
		}
		dim = Integer.parseInt (JOptionPane.showInputDialog ("Inserisci la dimensione del font"));
		while (!tipo.equalsIgnoreCase("serif") && !tipo.equalsIgnoreCase("monospaced") && !tipo.equalsIgnoreCase("sansserif"))
			tipo = JOptionPane.showInputDialog ("Inserisci il tipo di font (\"serif\",\"monospaced\", \"sansserif\")");
		while (!stile.equalsIgnoreCase("plain") && !stile.equalsIgnoreCase("italic") && !stile.equalsIgnoreCase("bold"))
			stile = JOptionPane.showInputDialog ("Inserisci lo stile del font (\"plain\",\"italic\", \"bold\")");
		msg = JOptionPane.showInputDialog ("Inserisci il messaggio che vuoi venga visualizzato");
		int st;
		if (stile.equalsIgnoreCase("plain"))
			st = 0;
		else if (stile.equalsIgnoreCase("bold"))
			st = 1;
		else	st = 2;
		
		//creazione del frame:
		JFrame f = new FrameInterattivo (new Color (r,g,b), new Font (tipo, st, dim), msg);
		
		//visualizzazione del frame:
		f.show();
	} 
}

//Classe non pubblica per l'implementazione del frame:
class FrameInterattivo extends JFrame
{
	//Costruttore:
	public FrameInterattivo (Color color, Font font, String msg)
	{
		setTitle ("Frame interattivo");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		//posiziono il frame al centro dello schermo:
		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension dimensioneSchermo = tk.getScreenSize();
		int larghezzaSchermo = dimensioneSchermo.width;
		int altezzaSchermo = dimensioneSchermo.height;
		setSize (larghezzaSchermo/2, altezzaSchermo/2);
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		
		//aggiungo il pannello al contentPane
		JPanel p = new PannelloInterattivo (color, font, msg);
		Container cp = getContentPane();
		cp.add (p);
	}
}

//Classe non pubblica per l'implementazione del pannello:
class PannelloInterattivo extends JPanel
{
	private Color c;
	private Font f;
	private String m;
	
	//Costruttore:
	public PannelloInterattivo (Color color, Font font, String msg)
	{
		super ();
		c = color;
		f = font;
		m = msg;
	}
	
	//metodi di accesso per le variabili di istanza:
	public Color getColor ()	{ return c; }
	public Font getFont ()		{ return f; }
	public String getString ()	{ return m; }
	
	//ridefinizione del metodo paintComponent():
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
		
		//setto il colore di sfondo del pannello:
		setBackground (Color.white);
		
		//ottengo le dimensioni del pannello:
		Dimension dimensionePannello = getSize();
		int larghezzaPannello = dimensionePannello.width;
		int altezzaPannello = dimensionePannello.height;
		
		//posiziono la stringa al centro del pannello (in realt non conosco le effettive dimensioni della stringa:
		int larghezzaStringa = 10;	/***/
		int altezzaStringa = 80;	/***/
		g.drawString (m, (larghezzaPannello-larghezzaStringa)/2, ((altezzaPannello-altezzaStringa)/2)+35);
	}
}