/* Applicazione che crea un frame con tre pulsanti che permettono di cambiarne lo sfondo */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

//Classe pubblica CambiaSfondoApp:
public class CambiaSfondoApp extends Object
{
	//main:
	public static void main (String[] args)
	{
		//creazione del frame:
		JFrame f = new CambiaSfondoFrame ();
		
		//visualizzazione del frame:
		f.show();
	}
}

//Classe CambiaSfondoFrame:
class CambiaSfondoFrame extends JFrame 
{
	private Dimension dimensioneSchermo;
	private int larghezzaSchermo;
	private int altezzaSchermo;
		
	//Costruttore:
	public CambiaSfondoFrame ()
	{
		setTitle ("Scegli il tuo colore preferito");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		Toolkit tk = Toolkit.getDefaultToolkit ();
		dimensioneSchermo = tk.getScreenSize();
		larghezzaSchermo = dimensioneSchermo.width;
		altezzaSchermo = dimensioneSchermo.height;
		
		setSize (larghezzaSchermo/2, altezzaSchermo/2);
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		
		CambiaSfondoPanel p = new CambiaSfondoPanel ();
		Container cp = getContentPane ();
		cp.add (p);
	}
	
	//metodi di accesso alle variabili di istanza:
	public Dimension getDimensioneSchermo () 		{ return dimensioneSchermo;	}
	public int getLarghezzaSchermo ()			{ return larghezzaSchermo;	}
	public int getAltezzaSchermo ()				{ return altezzaSchermo;	}
}

//Classe CambiaSfondoPanel:
class CambiaSfondoPanel extends JPanel implements ActionListener 
{
	//variabili di istanza:
	private JButton b1;
	private JButton b2;
	private JButton b3;
	private JButton b4;
	
	//Costruttore:
	public CambiaSfondoPanel ()
	{
		super ();
		
		//inizializzo le variabili di istanza (i JButton):
		b1 = new JButton ("Rosso");
		b2 = new JButton ("Blu");
		b3 = new JButton ("Giallo");
		b4 = new JButton ("Verde");
		
		//aggiungo i bottoni al pannello:
		add (b1);
		add (b2);
		add (b3);
		add (b4);
		
		//utilizzo il pannelo come listener degli eventi generati dai bottoni:
		b1.addActionListener (this);
		b2.addActionListener (this);
		b3.addActionListener (this);
		b4.addActionListener (this);
	}
	
	//paintComponent ():
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
	}
	
	//implementazione dell'unico metodo dell'interfaccia ActionListener:
	public void actionPerformed (ActionEvent e)
	{
		//per individuare quale fra i 4 bottoni ha generato l'evento utlizzo il metodo getSource():
		if (e.getSource() == b1)
		{
			System.out.println ("Sfondo rosso!");
			setBackground (Color.red);
		}
		else if (e.getSource() == b2)
		{
			System.out.println ("Sfondo blu!");
			setBackground (Color.blue);
		}
		else if (e.getSource() == b3)
		{
			System.out.println ("Sfondo giallo!");			
			setBackground (Color.yellow);
		}
		else
		{
			System.out.println ("Sfondo verde!");
			setBackground (Color.green);
		}
	}
}
