//Programma che visualizza un frame al centro dello schermo

import java.awt.*;
import javax.swing.*;

class FlexFrame extends JFrame
{
	private int larghezzaSchermo;
	private int altezzaSchermo;
		
	public FlexFrame ()
	{
		setTitle ("Frame");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
	
		Toolkit tk = Toolkit.getDefaultToolkit();	//ritorna il Toolkit di default
		Dimension dim = tk.getScreenSize();		//ritorna le dimensioni dello schermo
		
		larghezzaSchermo = (int)(dim.getWidth());		//memorizzo la larghezza dello schermo
		altezzaSchermo = (int)(dim.getHeight());		//memorizzo l'altezza dello schermo
		
		setSize (larghezzaSchermo/2, altezzaSchermo/2);	//il frame sar di dim. 1/4 rispetto allo schermo
		setLocation (0, 0);
	}
	
	//metodi di accesso alle variabili di istanza
	public int getLarghezzaSchermo()
	{	return larghezzaSchermo;	}
	
	public int getAltezzaSchermo()
	{	return altezzaSchermo;		}
	
}

public class CenteredFrame
{
	public static void main (String[] args)
	{
		//creo un nuovo frame
		FlexFrame f = new FlexFrame();
		f.setTitle ("Sono al centro dello schermo!!!");
		
		//setto la posizione corretta del frame:
		f.setLocation ((int)(f.getLarghezzaSchermo()-f.getSize().getWidth())/2,
				(int)(f.getAltezzaSchermo()-f.getSize().getHeight())/2);
		
		//visualizzo il frame:
		f.show();
	}
}
