/************************************* ESERCIZIO ***************************************

Rappresentare in un frame una faccia e permettere all'utente di scegliere il colore di faccia,
occhi, naso, bocca, capelli, mediante CheckBox o RadioButton

*****************************************************************************************/

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.awt.geom.*;

//Classe ColoraFacciaApp:
public class ColoraFacciaApp extends Object
{
	//main:
	public static void main (String[] args)
	{
		JFrame f = new ColoraFacciaFrame ();
		f.show();
	}
}

//Classe ColoraFacciaFrame:
class ColoraFacciaFrame extends JFrame
{
	private Dimension dimensioneSchermo;
	private int larghezzaSchermo;
	private int altezzaSchermo;
		
	//Costruttore:
	public ColoraFacciaFrame ()
	{
		//testo nella barra del titolo:
		setTitle ("Colora come preferisci la faccia");
		//chiusura dell'applicazione con la chiusura del frame:
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		//ottengo le dimensioni dello schermo mediante il Toolkit di default:
		Toolkit toolkit = Toolkit.getDefaultToolkit ();
		dimensioneSchermo = toolkit.getScreenSize ();
		larghezzaSchermo = dimensioneSchermo.width;
		altezzaSchermo = dimensioneSchermo.height;
		
		//setto la dimensione del frame in modo che sia 1/4 della dimensione dello schermo:
		setSize (larghezzaSchermo/2, altezzaSchermo/2);
		//posiziono il frame in modo che sia sempre al centro dello schermo:
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		//impedisco all'utente di ridimensionare il frame:
		setResizable (false);
		
		//ottengo il contentPane:
		Container contentPane = getContentPane();
		
		//imposto il layout del frame (due righe ed una colonna):
		contentPane.setLayout (new GridLayout (2,1));
		
		//creo due pannelli che aggiungo al contentPane del frame:
		ColoraFacciaPanel pannelloFaccia = new ColoraFacciaPanel ();
		SceltaUtentePanel pannelloScelta = new SceltaUtentePanel ();
		contentPane.add (pannelloFaccia);
		contentPane.add (pannelloScelta);
	}
	
	//metodi di accesso alle variabili di istanza:
	public Dimension getDimensioneSchermo ()		{ return dimensioneSchermo;	}
	public int getLarghezzaSchermo ()			{ return larghezzaSchermo;	}
	public int getAltezzaSchermo ()				{ return altezzaSchermo;	}
}

//Classe ColoraFacciaPanel:
class ColoraFacciaPanel extends JPanel
{
	//variabili di istanza:
	private Rectangle capelli;
	private Ellipse2D.Double occhioSx, occhioDx;
	private Rectangle naso;
	private Ellipse2D.Double bocca;
	private Ellipse2D.Double faccia;
		
	private int larghezzaPannello;
	private int altezzaPannello;
	
	//Costruttore:
	public ColoraFacciaPanel ()
	{
		super ();
		
		//imposto il colore di sfondo del pannello:
		setBackground (Color.white);
		
		//inizializzo le variabili di istanza:
		larghezzaPannello = getSize().width;
		altezzaPannello = getSize().height;
		
		int larghezzaCapelli = 3*larghezzaPannello/4;
		int altezzaCapelli = altezzaPannello/6;
		
		System.out.println ("Larghezza del pannello sup.: "+larghezzaPannello);
		System.out.println ("Altezza del pannello sup.: "+altezzaPannello);
		System.out.println ("Larghezza dei capelli: "+larghezzaCapelli);
		System.out.println ("Altezza dei capelli: "+altezzaCapelli);
		
		capelli = new Rectangle ((larghezzaPannello-larghezzaCapelli)/2, (altezzaPannello-altezzaCapelli)/2, larghezzaCapelli, altezzaCapelli);
	}
	
	//ridefinizione del metodo paintComponent (Graphics g):
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
		Graphics2D g2 = (Graphics2D)g;
		
		g2.setColor (Color.black);
		
		//disegno i capelli:
		g2.draw (capelli);
	}
}

//Classe SceltaUtentePanel
class SceltaUtentePanel extends JPanel implements ActionListener
{
	//Costruttore:
	public SceltaUtentePanel ()
	{
		super ();
	}
	
	//implementazione del metodo astratto actionPerformed della classe ActionListener:
	public void actionPerformed (ActionEvent e)
	{
	}
}
