/*	Applicazione che crea un frame il cui sfondo cambia colore man mano che esso viene ridimensionato.
	Il colore ha componente rossa pari a 128 fissa. La componente verde  proporzionale alla larghezza e 
	la componente blu  proporzionale all'altezza.
*/

import java.awt.*;
import javax.swing.*;

//Classe pubblica adibita alla creazione ed alla visualizzazione del frame:
public class ColoriVariabiliApp extends Object
{
	//main:
	public static void main (String[] args)
	{
		JFrame f = new ColoriVariabiliFrame ();
		
		f.show();
	}
}

//Classe non pubblica che implementa il Frame:
class ColoriVariabiliFrame extends JFrame
{
	//Cotruttore:
	public ColoriVariabiliFrame ()
	{
		setTitle ("Frame con colori variabili");
		setLocation (30, 25);
		setSize (400, 300);
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		ColoriVariabiliPanel p = new ColoriVariabiliPanel ();
		Container cp = getContentPane();
		cp.add (p);
	}
}

//Classe non pubblica che implementa il Panel:
class ColoriVariabiliPanel extends JPanel
{
	//Costruttore:
	public ColoriVariabiliPanel ()
	{
		//chiamata al costruttore della superclasse JPanel:
		super ();
	}
	
	//ridefinizione del metodo paintComponent():
	public void paintComponent (Graphics g)
	{
		super.paintComponent(g);
		
		//Ottengo le dimensioni del pannello:
		Dimension dimensionePannello = this.getSize();
		int larghezzaPannello = dimensionePannello.width;
		int altezzaPannello = dimensionePannello.height;
		
		//Ottengo le dimensioni dello schermo:
		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension dimensioneSchermo = tk.getScreenSize();
		int larghezzaSchermo = dimensioneSchermo.width;
		int altezzaSchermo = dimensioneSchermo.height;
		
		//Coloro opportunamente il pannello (in base alle dimensioni dello schermo):
		setBackground (new Color (	128,
						larghezzaPannello*256/larghezzaSchermo, 
						altezzaPannello*256/altezzaSchermo));
	}
	
}
