/********************* ESEMPIO PROVA IN ITINERE 2004 (per il testo vedi web)**************************/

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.io.*;
import java.awt.image.*;
import javax.imageio.*;
import javax.swing.filechooser.FileFilter;

//Classe EsempioProvaApp:
public class EsempioProvaApp
{
	//main:
	public static void main (String[] args)
	{
		//creazione del frame:
		JFrame f = new EsempioProvaFrame ();
		
		//visualizzazione del frame:
		f.show();
	}
}

//Classe EsempioProvaFrame:
class EsempioProvaFrame extends JFrame implements ActionListener
{
	//variabili di istanza:
	private EsempioProvaPanel1 p1;
	private EsempioProvaPanel2 p2;
	private JMenuItem inverti, rosso, giallo, carica, elabora;
	private JFileChooser fileChooser;
	private JLabel label;
	private BufferedImage image;
	private boolean check = true;
		
	//Costruttore:
	public EsempioProvaFrame ()
	{
		//testo nella barra del titolo:
		setTitle ("Esempio prova in itinere 2004");
		//operazione di default di chiusura:
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		//setto la locazione in cui verr visualizzato il frame:
		setLocation (20, 20);
		//setto la dimesione del frame:
		setSize (600, 480);
		
		//creo la barra dei menu:
		JMenuBar barraMenu = new JMenuBar();
		//aggiungo la barra dei menu al frame:
		this.setJMenuBar (barraMenu);
		
		//creo i due menu:
		JMenu menu1 = new JMenu ("Menu 1");
		JMenu menu2 = new JMenu ("Menu 2");
		
		//aggiungo i due menu alla barra precedentemente creata:
		barraMenu.add (menu1);
		barraMenu.add (menu2);
		
		//creo tutti gli elementi di menu che sono necessari:
		inverti = new JMenuItem ("Inverti");
		rosso = new JMenuItem ("Rosso");
		giallo = new JMenuItem ("Giallo");
		carica = new JMenuItem ("Carica immagine");
		elabora = new JMenuItem ("Elabora immagine");
		
		//aggiungo gli elementi di menu ai menu:
		menu1.add (inverti);
		menu1.add (rosso);
		menu1.add (giallo);
		menu2.add (carica);
		menu2.add (elabora);
		
		fileChooser = new JFileChooser ();
		label = new JLabel();
		
		fileChooser.setAcceptAllFileFilterUsed (false);
		//aggiungo il filtro per le immagini jpg e png:
		fileChooser.addChoosableFileFilter (new PNGFilter());
		fileChooser.addChoosableFileFilter (new JPGFilter());
		
		//ottengo il contentPane:
		Container cp = getContentPane ();
		
		//setto il layout del frame
		cp.setLayout (new GridLayout (1,2));
		
		//creo i due pannelli necessari:
		p1 = new EsempioProvaPanel1 (check);
		p2 = new EsempioProvaPanel2 ();
		
		p2.add (label);
		
		//aggiungo i pannelli al contentPane:
		cp.add (p1);
		cp.add (p2);
		
		//scelgo il frame stesso come ascoltatore degli eventi generati dai menu:
		inverti.addActionListener (this);
		rosso.addActionListener (this);
		giallo.addActionListener (this);
		carica.addActionListener (new OpenListener (label, fileChooser, image));
		elabora.addActionListener (this);
	}
	
	//implementazione del metodo ActionPerformed() dell'interfaccia ActionListener:
	public void actionPerformed (ActionEvent e)
	{
		Object source = e.getSource();
		if 	(source == rosso)
			p1.setColoreRettangolo (Color.red);
		else if (source == giallo)
			p1.setColoreRettangolo (Color.yellow);
		else if (source == inverti)
		{
			check = !check;
			p1.setCheck (check);
		}
		else if (source == elabora)
			negativo ();
	}
	
	private void negativo()
	{
		ImageIcon ic = (ImageIcon)(label.getIcon());
		BufferedImage image = (BufferedImage)(ic.getImage());
		//Creo il contesto grafico dell'immagine
		Graphics2D g2=image.createGraphics();
		//Imposto come colore il bianco
		g2.setColor(Color.white);
		//Imposto la modalit XOR e come colore XOR il nero
		g2.setXORMode(Color.black);
		g2.fillRect(0,0,image.getWidth(),image.getHeight());
		//Rilascio le risorse
		g2.dispose();
		//Ridisegno il pannello
		p2.repaint();
	}

}

//Classe EsempioProvaPanel1:
class EsempioProvaPanel1 extends JPanel
{
	//varianili di istanza:
	private Color coloreRettangolo, coloreCerchio, negativo;
	private int larghezzaRettangolo, altezzaRettangolo, latoMinore;
	private boolean check;
		
	//Costruttore:
	public EsempioProvaPanel1 (boolean check)
	{
		super ();
		coloreRettangolo = Color.black;
		this.check = check;
	}
	
	//ridefinizione del metodo paintComponent (Graphics g):
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
		
		larghezzaRettangolo = getSize().width-1;
		altezzaRettangolo = getSize().height/2;
		
		negativo = new Color (
			255-coloreRettangolo.getRed(),
			255-coloreRettangolo.getGreen(),
			255-coloreRettangolo.getBlue());
		
		//trovo il lato minore del rettangolo (per disegnare il cerchio inscritto):
		if (larghezzaRettangolo < altezzaRettangolo)
			latoMinore = larghezzaRettangolo;
		else 	latoMinore = altezzaRettangolo;
		//setto il colore del contesto grafico:
		
		g.setColor (coloreRettangolo);
		if (check)
		{
			//disegno il rettangolo:
			g.fillRect (0, (getSize().height-altezzaRettangolo)/2, larghezzaRettangolo, altezzaRettangolo);
			g.setColor (negativo);
			//disegno un cerchio inscritto al rettangolo:
			g.drawOval ((getSize().width-latoMinore)/2, (getSize().height-latoMinore)/2, latoMinore, latoMinore);
		}
		else
		{
			//disegno il rettangolo:
			g.drawRect (0, (getSize().height-altezzaRettangolo)/2, larghezzaRettangolo, altezzaRettangolo);
			g.setColor (negativo);
			//disegno un cerchio inscritto al rettangolo:
			g.fillOval ((getSize().width-latoMinore)/2, (getSize().height-latoMinore)/2, latoMinore, latoMinore);
		}
	}

	//metodi get e set per le variabili di istanza:
	public Color getColoreRettangolo ()			
		{ return coloreRettangolo;		}
	public Color getColoreCerchio ()			
		{ return coloreCerchio;			}
	public void setColoreRettangolo (Color c)		
		{ coloreRettangolo = c; repaint();	}
	public void setColoreCerchio (Color c)			
		{ coloreCerchio = c; repaint();		}
	public void setCheck (boolean b)
		{ check = b; repaint ();}
}

//Classe EsempioProvaPanel2:
class EsempioProvaPanel2 extends JPanel
{	
	//Costruttore:
	public EsempioProvaPanel2 ()
	{
		super ();
	}	
}

//Classe OpenListener:
class OpenListener implements ActionListener 
{
	//variabili di istanza:
	private JLabel label;
	private JFileChooser fileChooser;
	private BufferedImage image;
		
	//Costruttore:
	public OpenListener (JLabel label, JFileChooser fileChooser, BufferedImage image)
	{
		this.label = label;
		this.fileChooser = fileChooser;
		this.image = image;
	}
	
	//definizione del metodo actionPerformed dell'interfaccia ActionListener:
	public void actionPerformed (ActionEvent e)
	{
		fileChooser.setDialogType (JFileChooser.OPEN_DIALOG);
		int risposta = fileChooser.showOpenDialog(label);
		
		if (risposta == fileChooser.APPROVE_OPTION) //Se ho premuto il tasto apri
		{
			//recupero il file selezionato
			File file = fileChooser.getSelectedFile();
			try
			{
				//provo ad aprire l'immagine
				image = ImageIO.read(file);
				
				//disegno l'immagine:
				label.setIcon (new ImageIcon (image));
			}
			catch (Exception ex)
			{
				System.out.println ("Eccezione: "+ex);
			}
		}
	}
}

//Classe JPGFilter:
class JPGFilter extends FileFilter
{
	//implemetazione dei metodi astratti della superclasse FileFilter
	public boolean accept (File f)
	{
		return f.getName().toLowerCase().endsWith (".jpg") || f.isDirectory();
	}
	
	public String getDescription ()
	{
		return "Immagine jpg";
	}
}

//Classe PNGFilter:
class PNGFilter extends FileFilter
{
	//implemetazione dei metodi astratti della superclasse FileFilter
	public boolean accept (File f)
	{
		return f.getName().toLowerCase().endsWith (".png") || f.isDirectory();
	}
	
	public String getDescription ()
	{
		return "Immagine png";
	}
}
