/* Applicazione che visualizza un file immagine all'interno di un frame */

import java.awt.*;
import javax.swing.*;

//Classe pubblica ImageApplicazione:
public class ImageApplicazione
{
	//main:
	public static void main (String[] args)
	{
		//creazione del frame:
		JFrame f = new ImageFrame ();
		
		//visualizzazione del frame:
		f.show ();
	}
}

//Classe ImageFrame:
class ImageFrame extends JFrame
{
	//Costruttore:
	public ImageFrame ()
	{
		setTitle ("Sculpture Frame");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension dimensioneSchermo = tk.getScreenSize();
		int larghezzaSchermo = dimensioneSchermo.width;
		int altezzaSchermo = dimensioneSchermo.height;
		
		setSize (larghezzaSchermo/2, altezzaSchermo/2);
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		
		Container cp = getContentPane();
		cp.add (new ImagePanel ());
	}
}

//Classe ImagePanel:
class ImagePanel extends JPanel
{
	private Image image;
	private String name;
	
	//Costruttore:
	public ImagePanel ()
	{
		//inizializzo l'attributo d'istanza image:
		Toolkit tk = Toolkit.getDefaultToolkit ();
		name = "sculpture.jpg";
		image = tk.getImage (name);
		
		//creo un MediaTracker:
		MediaTracker tracker = new MediaTracker (this);
		//aggiungo l'immagine al tracker, assegnandole ID 0:
		tracker.addImage (image, 0);
		//carico l'immagine:
		System.out.println ("Sto caricando l'immagine");
		try
		{
			tracker.waitForID (0);
		}
		catch (InterruptedException e)
		{
			System.out.println ("Si  verificata un'eccezione "+e);
			return;
		}
	}
	
	//ridefinizione del metodo paintComponent():
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
		
		//disegno l'immagine caricata mediante il MediaTracker:
		System.out.println ("Sto disegnando l'immagine");
		//g.drawImage (image, 0, 0, null);
		g.drawImage (image, 0,  0, getSize().width, getSize().height, null);
		
		System.out.println ("Sto scrivendo il nome dell'immagine");
		g.setColor (Color.yellow);
		g.setFont (new Font ("Serif", Font.ITALIC+Font.BOLD, 48));
		g.drawString (name, 20, 55);
	}
}
