// Piccola applicazione che disegna linee casuali all'interno di un frame:

import java.awt.*;
import javax.swing.*;

//Classe LineeCasualiApp:
public class LineeCasualiApp extends Object
{
	//main:
	public static void main (String[] args)
	{
		JFrame f = new LineeCasualiFrame ();
		f.show();
	}
}

//Classe LineeCasualiFrame:
class LineeCasualiFrame extends JFrame 
{
	//Costruttore:
	public LineeCasualiFrame ()
	{
		setTitle ("Tante linee casuali!");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension dimensioneSchermo = tk.getScreenSize();
		int larghezzaSchermo = dimensioneSchermo.width;
		int altezzaSchermo = dimensioneSchermo.height;
		setSize (larghezzaSchermo/2, altezzaSchermo/2);
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		LineeCasualiPanel p = new LineeCasualiPanel();
		Container cp = getContentPane();
		cp.add (p);
	}
}

//Classe LineeCasualiPanel:
class LineeCasualiPanel extends JPanel
{
	//Costruttore:
	public LineeCasualiPanel ()
	{
		super();
		setBackground (Color.white);
	}
	
	//paintComponent():
	public void paintComponent (Graphics g)
	{
		super.paintComponent(g);
		g.setColor (Color.white);
		for (long i = 0; i < 700; i++)
		{
			g.setColor (new Color((int)(255*Math.random()), (int)(255*Math.random()), (int)(255*Math.random())));
			int x1 = (int)(getSize().width*Math.random());
			int x2 = (int)(getSize().width*Math.random());
			int y1 = (int)(getSize().height*Math.random());
			int y2 = (int)(getSize().height*Math.random());
			g.drawLine (x1,y1,x2,y2);
		}
	}
}
