/* Applicazione che disegna linee casuali all'interno di una corona circolare rappresentata in un frame */

import java.awt.*;
import javax.swing.*;

//Classe pubblica LineeCasualiApp3:
public class LineeCasualiApp3 extends Object
{
	//main:
	public static void main (String[] args)
	{
		//creazione del frame:
		JFrame frame = new LineeCasualiFrame3 ();
		
		//visualizzazione del frame:
		frame.show();
	}
}

//Classe LineeCasualiFrame3:
class LineeCasualiFrame3 extends JFrame
{
	//Costruttore:
	public LineeCasualiFrame3 ()
	{
		setTitle ("Tante linee casuali!");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension dimensioneSchermo = tk.getScreenSize();
		int larghezzaSchermo = dimensioneSchermo.width;
		int altezzaSchermo = dimensioneSchermo.height;
		setSize (600, 600);
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		LineeCasualiPanel3 p = new LineeCasualiPanel3 ();
		Container cp = getContentPane ();
		cp.add (p);
	}
}

//Classe LineeCasualiPanel3:
class LineeCasualiPanel3 extends JPanel
{
	//Costruttore:
	public LineeCasualiPanel3 ()
	{
		super();
		setBackground (Color.yellow);
	}
	
	//paintComponent():
	public void paintComponent (Graphics g)
	{
		super.paintComponent(g);
		
		//ottengo le dimensioni del pannello:
		int larghezzaPannello = this.getSize().width;
		int altezzaPannello = this.getSize().height;
		
		//rappresento una circonferenza di colore nero:
		g.setColor (Color.gray);
		g.drawOval (0, 0, larghezzaPannello-1, altezzaPannello-1);
		
		//rappresento una circonferenza interna di colore nero:
		g.drawOval (larghezzaPannello/4, altezzaPannello/4, (larghezzaPannello-1)/2, (altezzaPannello-1)/2);
		
		//disegno le linee casuali:
		g.setColor (Color.blue);
		for (int i = 0; i < (int)(1000*Math.random()+1); i++)
			g.drawLine(0,0,0,0);
	}
}
