//RettangoliEllissiApp2.java:

import java.awt.*;
import javax.swing.*;

public class RettangoliEllissiApp2 extends Object
{
	//main:
	public static void main (String[] args)
	{
		JFrame f = new RettangoliEllissiFrame2 ();
		f.show();
	}
}

//Classe RettangoliEllissiFrame:
class RettangoliEllissiFrame2 extends JFrame
{
	//Costruttore:
	public RettangoliEllissiFrame2 ()
	{
		setTitle ("Applicazione che visualizza randomicamente rettangoli ed ellissi colorati");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		Toolkit tk = Toolkit.getDefaultToolkit ();
		Dimension dimensioneSchermo = tk.getScreenSize ();
		int larghezzaSchermo = dimensioneSchermo.width;
		int altezzaSchermo = dimensioneSchermo.height;
		setSize (larghezzaSchermo/2, altezzaSchermo/2);
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		JPanel p = new RettangoliEllissiPanel2 ();
		Container cp = getContentPane ();
		cp.add (p);
	}
}

//Classe RettangoliEllissiPanel:
class RettangoliEllissiPanel2 extends JPanel
{
	//Costruttore:
	public RettangoliEllissiPanel2 ()
	{
		super ();
		setBackground (Color.white);
	}
	
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
		
		//ottengo le dimensioni del pannello:
		int larghezzaPannello = getSize().width;
		int altezzaPannello = getSize().height;
		
		//Disegno casualmente rettangoli:
		System.out.println ("Rettangoli casuali colorati!");
		for (int i = 0; i < (int)(100*Math.random()+1); i++)
		{
			g.setColor (new Color ((int)(255*Math.random()), (int)(255*Math.random()), (int)(255*Math.random())));
			int larghezzaRettangolo = (int)(larghezzaPannello*Math.random()+1);
			int altezzaRettangolo = (int)(altezzaPannello*Math.random()+1);
			g.fillRect (	(int)((larghezzaPannello-larghezzaRettangolo)*Math.random()), 
					(int)((larghezzaPannello-larghezzaRettangolo)*Math.random()),
					larghezzaRettangolo,
					altezzaRettangolo);
		}
		
		//Disegno casualmente ellissi:
		System.out.println ("Ellissi casuali colorate!");
		for (int i = 0; i < (int)(200*Math.random()+1); i++)
		{
			g.setColor (new Color ((int)(255*Math.random()), (int)(255*Math.random()), (int)(255*Math.random())));
			int larghezzaEllisse = (int)(larghezzaPannello*Math.random()+1);
			int altezzaEllisse = (int)(altezzaPannello*Math.random()+1);
			g.fillOval (	(int)((larghezzaPannello-larghezzaEllisse)*Math.random()), 
					(int)((larghezzaPannello-larghezzaEllisse)*Math.random()),
					larghezzaEllisse,
					altezzaEllisse);
		}
		
		//Disegno casualmente rettangoli con bordi arrotondati:
		System.out.println ("Rettangoli con bordi arrotondati casuali colorati!");
		for (int i = 0; i < (int)(100*Math.random()+1); i++)
		{
			g.setColor (new Color ((int)(255*Math.random()), (int)(255*Math.random()), (int)(255*Math.random())));
			int larghezzaRettangolo = (int)(larghezzaPannello*Math.random()+1);
			int altezzaRettangolo = (int)(altezzaPannello*Math.random()+1);
			g.fillRoundRect (	(int)((larghezzaPannello-larghezzaRettangolo)*Math.random()), 
					(int)((larghezzaPannello-larghezzaRettangolo)*Math.random()),
					larghezzaRettangolo,
					altezzaRettangolo,
					(int)(20*Math.random()+1),
					(int)(20*Math.random()+1));
		}
	}
}
