/* Applicazione che visualizza 16 frame numerati di eguali dimensioni che non si sovrappongono fra loro nello schermo */

import java.awt.*;
import javax.swing.*;

//Classe pubblica per l'inizializzazione dei frame:
public class SediciFrames extends Object
{
	public static void main (String[] args)
	{
		//istanzio un array di 16 frame:
		UnFrame[] sediciFrames = new UnFrame[16];
		
		//utlizzo il toolkit per ottenere informazioni sulla dimensione dello schermo:
		Toolkit tk = Toolkit.getDefaultToolkit();
		Dimension dim = tk.getScreenSize();
		int x = (int)dim.getWidth();
		int y = (int)dim.getHeight();
		
		//inserisco i frames all'interno dell'array:
		for (int i = 0; i < sediciFrames.length; i++)
			sediciFrames[i] = new UnFrame();
		
		//setto le dimensioni di ciascun frame:
		for (int i = 0; i < sediciFrames.length; i++)
			sediciFrames[i].setSize (x/4, y/4);
		
		int m, n;
		//colloco i frames nelle posizioni corrette:
		sediciFrames[0].setLocation(m=0,n=0);
		for (int i = 1; i < 4; i++)
			sediciFrames[i].setLocation(m+=sediciFrames[i-1].getWidth(),n);
		for (int i = 4; i < 16; i++)
			sediciFrames[i].setLocation(sediciFrames[i-4].getLocation().x,sediciFrames[i-4].getLocation().y+sediciFrames[i].getHeight());
		
		//visualizzazione dei frames:
		for (int i = 0; i < sediciFrames.length; i++)
			sediciFrames[i].show();
		
	}
}

//Classe pubblica che ralizza un frame:
class UnFrame extends JFrame
{
	//Costruttore:
	public UnFrame ()
	{
		setDefaultCloseOperation (EXIT_ON_CLOSE);
	}
}
