//Applicazione che visualizza un frame al centro dello schermo in base alla risoluzione corrente

import java.awt.*;
import javax.swing.*;

class SimpleFrame extends JFrame
{
	private int larghezzaSchermo;
	private int altezzaSchermo;
		
	public SimpleFrame ()
	{
		setTitle ("SimpleFrame");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		//istanzio una variabile di tipo Toolkit
		Toolkit tk = Toolkit.getDefaultToolkit();
		
		Dimension dimSchermo = tk.getScreenSize();
		
		//setto la variabile larghezzaSchermo
		larghezzaSchermo = dimSchermo.width;
		
		//setto la variabile altezzaSchermo
		altezzaSchermo = dimSchermo.height;
		
		//il frame avr dimensione 1/64 rispetto alla dimensione dello schermo
		setSize (larghezzaSchermo/8, altezzaSchermo/8);
		
		setLocation (0, 0); //non necessario
	}
	
	//metodi di accesso alle variabili di istanza:
	public int getLarghezzaSchermo () { return larghezzaSchermo; }
	public int getAltezzaSchermo () { return altezzaSchermo; }
}

public class SimpleFrameTest
{
	public static void main (String[] args)
	{
		JFrame f = new SimpleFrame ();
		f.show();
	}
}
