/************************************************** ESERCIZIO **********************************************

Creare un frame con una scritta centrata in esso.

La dimensione della scritta cambia se si schiacciano i tasti corrispondenti ai numeri (0 grandezza minima, 9 
grandezza massima).

Il colore della scritta cambia come segue:
-	il valore del rosso in tale colore aumenta di una unit (fino a 255) ogni volta che schiaccio "r", diminuisce
	di una unit ogni volta che schiaccio "e";
-	il valore del verde in tale colore aumenta di una unit (fino a 255) ogni volta che schiaccio "g", diminuisce
	di una unit ogni volta che schiaccio "f";
-	il valore del blu in tale colore aumenta di una unit (fino a 255) ogni volta che schiaccio "b", diminuisce
	di una unit ogni volta che schiaccio "v";

*************************************************************************************************************/

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.font.*;
import java.awt.geom.*;

//Classe pubblica StringaVariabileApp:
public class StringaVariabileApp extends Object
{
	//main:
	public static void main (String[] args)
	{
		//creazione del frame:
		JFrame f = new StringaVariabileFrame ();
		
		//visualizzazione del frame:
		f.show();
	}
}

//Classe StringaVariabileFrame che implementa il frame per l'applicazione:
class StringaVariabileFrame extends JFrame implements KeyListener
{
	//variabili di istanza:
	private Dimension dimensioneSchermo;
	private int larghezzaSchermo, altezzaSchermo;
	public StringaVariabilePanel pannello;
		
	//Costruttore:
	public StringaVariabileFrame ()
	{
		setTitle ("La stringa che cambia dimensione");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		//ottengo le dimensioni dello schermo:
		Toolkit tk = Toolkit.getDefaultToolkit ();
		dimensioneSchermo = tk.getScreenSize ();
		larghezzaSchermo = dimensioneSchermo.width;
		altezzaSchermo = dimensioneSchermo.height;
		
		//imposto la grandezza del frame (1/4 dello schermo):
		setSize (larghezzaSchermo/2, altezzaSchermo/2);
		//imposto la posizione del frame al centro dello schermo:
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		
		//aggiungo il nuovo pannello al contentPane:
		Container cp = getContentPane();
		pannello = new StringaVariabilePanel ();
		cp.add (pannello);
		
		//creo ed aggiungo al frame l'ascoltatore degli eventi della tastiera:
		addKeyListener (this);
	}
	
	//metodi di accesso alle variabili di istanza:
	public Dimension getDimensioneSchermo ()		{ return dimensioneSchermo;	}
	public int getLarghezzaSchermo ()			{ return larghezzaSchermo;	}
	public int getAltezzaSchermo ()				{ return altezzaSchermo;	}
	
	/******** implementazione dei 3 metodi astratti dell'interfaccia KeyListener *********/
	
	//metodo per gestire l'evento keyTyped:
	public void keyTyped (KeyEvent e)
	{
		System.out.println ("Si  verificato un evento: "+e);
	}
	
	//metodo per gestire l'evento keyPressed:
	public void keyPressed (KeyEvent e)
	{

		System.out.println ("Si  verificato un evento: "+e);
		
		//aggiungo il codice per modificare la stringa del pannello:
		int keyCode = e.getKeyCode();
		
		System.out.println ("Il codice del carattere che ha generato l'evento  "+keyCode);
		if (keyCode >= KeyEvent.VK_0 && keyCode <= KeyEvent.VK_9)
			pannello.setDimensioneCarattere (keyCode - 16);
		
		/*
		else if (keyCode == KeyEvent.VK_1)
		{
			pannello.setDimensioneCarattere (36);
		}
		else if (keyCode == KeyEvent.VK_2)
		{
			pannello.setDimensioneCarattere (40);
		}
		else if (keyCode == KeyEvent.VK_3)
		{
			pannello.setDimensioneCarattere (44);
		}
		else if (keyCode == KeyEvent.VK_4)
		{
			pannello.setDimensioneCarattere (48);
		}
		else if (keyCode == KeyEvent.VK_5)
		{
			pannello.setDimensioneCarattere (52);
		}
		else if (keyCode == KeyEvent.VK_6)
		{
			pannello.setDimensioneCarattere (56);
		}
		else if (keyCode == KeyEvent.VK_7)
		{
			pannello.setDimensioneCarattere (60);
		}
		else if (keyCode == KeyEvent.VK_8)
		{
			pannello.setDimensioneCarattere (64);
		}
		else if (keyCode == KeyEvent.VK_9)
		{
			pannello.setDimensioneCarattere (68);
		}
		*/
		
		if (keyCode == KeyEvent.VK_R && pannello.getColoreStringa().getRed() < 255)
			pannello.setColoreStringa (
			pannello.getColoreStringa().getRed() + 1, 
			pannello.getColoreStringa().getGreen(), 
			pannello.getColoreStringa().getBlue());
			
		if (keyCode == KeyEvent.VK_G && pannello.getColoreStringa().getGreen() < 255)
			pannello.setColoreStringa (
			pannello.getColoreStringa().getRed(), 
			pannello.getColoreStringa().getGreen() + 1, 
			pannello.getColoreStringa().getBlue());
		
		if (keyCode == KeyEvent.VK_B && pannello.getColoreStringa().getBlue() < 255)
			pannello.setColoreStringa (
			pannello.getColoreStringa().getRed(), 
			pannello.getColoreStringa().getGreen(), 
			pannello.getColoreStringa().getBlue() + 1);
		
		if (keyCode == KeyEvent.VK_E && pannello.getColoreStringa().getGreen() > 0)
			pannello.setColoreStringa (
			pannello.getColoreStringa().getRed() - 1, 
			pannello.getColoreStringa().getGreen(), 
			pannello.getColoreStringa().getBlue());
		
		if (keyCode == KeyEvent.VK_F && pannello.getColoreStringa().getGreen() > 0)
			pannello.setColoreStringa (
			pannello.getColoreStringa().getRed(), 
			pannello.getColoreStringa().getGreen() - 1, 
			pannello.getColoreStringa().getBlue());
		
		if (keyCode == KeyEvent.VK_V && pannello.getColoreStringa().getGreen() > 0)
			pannello.setColoreStringa (
			pannello.getColoreStringa().getRed(), 
			pannello.getColoreStringa().getGreen(), 
			pannello.getColoreStringa().getBlue() - 1);
		
		pannello.repaint();
	}
	
	//metodo per gestire l'evento keyRelased:
	public void keyReleased (KeyEvent e)
	{
		System.out.println ("Si  verificato un evento: "+e);
	}

}

//Classe StringaVariabilePanel che implementa il pannello per l'applicazione:
class StringaVariabilePanel extends JPanel
{
	//variabili di istanza:
	private String stringa;
	private Color coloreStringa;
	private Font f;
	
	//Costruttore:
	public StringaVariabilePanel ()
	{
		super ();
		
		//inizializzo le variabili di istanza:
		stringa = "FABIO";
		coloreStringa = Color.black;
		
		//setto il colore di sfondo del pannello:
		setBackground (Color.white);
		
		f = new Font ("Sanserif", Font.BOLD, 32);
	}
	
	//ridefinizione del metodo paintComponent ():
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
		Graphics2D g2 = (Graphics2D)g;
		
		//creo un nuovo font:
		//utilizzo il font per il contesto grafico:
		g2.setFont (f);
		
		//misuro le dimensioni della stringa:
		FontRenderContext context = g2.getFontRenderContext ();
		Rectangle2D bounds = f.getStringBounds (stringa, context);
		
		double x = (getWidth() - bounds.getWidth()) / 2;
		double y = (getHeight() - bounds.getHeight()) /2;
		//aggiungo l'ascesa del carattere per raggiungere la linea di base:
		double ascent = -bounds.getY();
		double baseY = y + ascent;
		
		//setto il colore del contesto grafico:
		g2.setColor (coloreStringa);
		
		//disegno la stringa al centro del pannello:
		g2.drawString (stringa, (int)x, (int)baseY);
		
	}
	
	//metodo per modificare la dimensione del carattere della stringa:
	public void setDimensioneCarattere (int dim)
	{
		f = new Font ("Sansserif", Font.BOLD, dim);
	}
	
	//metodo di accesso dellla variabile di istanza coloreStringa:
	public Color getColoreStringa ()
	{
		return coloreStringa;
	}
	
	//metodo di modifica della variabile di istanza coloreStringa:
	public void setColoreStringa (int r, int g, int b)
	{
		coloreStringa = new Color (r,g,b);
	}
}
