/* Piccola applicazione che visualizza un JButton all'interno di un frame  e gestisce l'evento della sua pressione */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;	//package contente l'interfaccia ActionListener

//Classe pubblica TestButton:
public class TestButton2 extends Object
{
	//main:
	public static void main (String[] args)
	{
		//creazione del frame:
		JFrame f = new ButtonFrame2 ();
		
		//visualizzazione del frame:
		f.show();
	}
}

//Classe ButtonFrame:
class ButtonFrame2 extends JFrame
{
	//Costruttore:
	public ButtonFrame2 ()
	{
		setTitle ("Cambia lo sfondo");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		setSize (600, 480);
		setLocation (50, 50);
		Container cp = getContentPane();
		cp.add (new ButtonPanel2 ());
	}
}

//Classe ButtonPanel:
class ButtonPanel2 extends JPanel implements ActionListener
{
	//variabile d'istanza: un JButton:
	private JButton button;
	
	//Costruttore:
	public ButtonPanel2 ()
	{
		super ();
		
		//setto background e foreground del pannello:
		//setBackground (Color.gray);
		setForeground (Color.red);
		
		//aggiungo un JButton al pannello:)
		button = new JButton ("Altro colore?");
		add (button);
		
		//rendo il pannello stesso ascoltatore degli eventi del bottone:
		button.addActionListener (this);
	}
	
	//paintComponent():
	public void paintComponent (Graphics g)
	{
		super.paintComponent(g);
	}
	
	/* poich la classe ButtonPanel2 implementa l'interfaccia ActionListener sono
	tenuto ad implementare TUTTI i suoi metodi astratti, in questo caso ActionPerformed() */
	public void actionPerformed (ActionEvent e)
	{
		setBackground (new Color ((int)(255*Math.random()), (int)(255*Math.random()), (int)(255*Math.random())));
		System.out.println ("Il colore attuale  R:"+getBackground().getRed()+" G:"+getBackground().getGreen()+" B:"+getBackground().getBlue());
	}
}
