// Applicazione che testa i principali componenti dell'interfaccia grafica

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;

//Classe TestLayoutApp:
public class TestLayoutApp extends Object
{
	//main:
	public static void main (String[] args)
	{
		JFrame frame1 = new TestLayoutFrame ();
		frame1.show();
	}
}

//Classe TestLayoutFrame:
class TestLayoutFrame extends JFrame
{
	private Dimension dimensioneSchermo;
	private int larghezzaSchermo;
	private int altezzaSchermo;
	
	//Costruttore:
	public TestLayoutFrame ()
	{
		setTitle ("Utilizzo dei layout");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		Toolkit toolkit = Toolkit.getDefaultToolkit ();
		dimensioneSchermo = toolkit.getScreenSize ();
		larghezzaSchermo = dimensioneSchermo.width;
		altezzaSchermo = dimensioneSchermo.height;
		
		setSize (larghezzaSchermo/2, altezzaSchermo/2);
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		
		//ottengo il contentPane:
		Container contentPane = getContentPane();
		contentPane.setLayout (new GridLayout(2,1));
		
		//creo due pannelli:
		JPanel pannello1 = new TestLayoutPanel (Color.red);
		JPanel pannello2 = new TestLayoutPanel (Color.black);
		
		//aggiungo i pannelli al contentPane:
		contentPane.add (pannello1);
		contentPane.add (pannello2);
	}
	
	//metodi di accesso:
	public Dimension getDimensioneSchermo ()		{ return dimensioneSchermo;	}
	public int getLarghezzaSchermo ()			{ return larghezzaSchermo;	}
	public int getAltezzaSchermo ()				{ return altezzaSchermo;	}
}

//Classe TestLayoutPanel:
class TestLayoutPanel extends JPanel
{
	private Color backgroundColor;
		
	//Costruttore:
	public TestLayoutPanel (Color c)
	{
		super ();
		backgroundColor = c;
		setBackground (backgroundColor);
		
		//setto il layout predefinito del pannello:
		setLayout (new BorderLayout());
		
		//creo 5 bottoni:
		JButton bottone1, bottone2, bottone3, bottone4, bottone5;
		bottone1 = new JButton ("Bottone 1");
		bottone2 = new JButton ("Bottone 2");
		bottone3 = new JButton ("Bottone 3");
		bottone4 = new JButton ("Bottone 4");
		bottone5 = new JButton ("Bottone 5");
		
		//aggiungo i bottoni al pannello:
		add (bottone1, "North");
		add (bottone2, "South");
		add (bottone3, "West");
		add (bottone4, "East");
		add (bottone5, "Center");
	}
	
	public Color getBackgroundColor ()			{ return backgroundColor;	}
}
