// Applicazione che testa i principali componenti dell'interfaccia grafica

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;

//Classe TestLayoutApp:
public class TestLayoutApp2 extends Object
{
	//main:
	public static void main (String[] args)
	{
		JFrame frame1 = new TestLayoutFrame2 ();
		frame1.show();
	}
}

//Classe TestLayoutFrame:
class TestLayoutFrame2 extends JFrame
{
	private Dimension dimensioneSchermo;
	private int larghezzaSchermo;
	private int altezzaSchermo;
	
	//Costruttore:
	public TestLayoutFrame2 ()
	{
		setTitle ("Utilizzo dei layout");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		Toolkit toolkit = Toolkit.getDefaultToolkit ();
		dimensioneSchermo = toolkit.getScreenSize ();
		larghezzaSchermo = dimensioneSchermo.width;
		altezzaSchermo = dimensioneSchermo.height;
		
		setSize (larghezzaSchermo/2, altezzaSchermo/2);
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		
		//ottengo il contentPane:
		Container contentPane = getContentPane();
		
		contentPane.setLayout (new GridLayout (3,2));
		for (int i = 0; i < 6; i++)
			contentPane.add (new TestLayoutPanel2(new Color ((int)(255*Math.random()),(int)(255*Math.random()),(int)(255*Math.random()))));
	}
	
	//metodi di accesso:
	public Dimension getDimensioneSchermo ()		{ return dimensioneSchermo;	}
	public int getLarghezzaSchermo ()			{ return larghezzaSchermo;	}
	public int getAltezzaSchermo ()				{ return altezzaSchermo;	}
}

//Classe TestLayoutPanel:
class TestLayoutPanel2 extends JPanel
{
	private Color backgroundColor;
		
	//Costruttore:
	public TestLayoutPanel2 (Color c)
	{
		super ();
		
		backgroundColor = c;
		setBackground (backgroundColor);
	}
}
