// TestTimerApp.java:

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class TestTimerApp extends Object
{
	//main:
	public static void main (String[] args)
	{
		JFrame f = new TimerFrame();
		f.show();
	}
}

//Classe TimerFrame:
class TimerFrame extends JFrame
{
	private Dimension dimensioneSchermo;
	private int larghezzaSchermo, altezzaSchermo;
	
	//Costruttore:
	public TimerFrame ()
	{
		setTitle ("Animazione");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		Toolkit tk = Toolkit.getDefaultToolkit ();
		dimensioneSchermo = tk.getScreenSize ();
		larghezzaSchermo = dimensioneSchermo.width;
		altezzaSchermo = dimensioneSchermo.height;
		
		setSize (larghezzaSchermo/2, altezzaSchermo/2);
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		
		Container cp = getContentPane ();
		cp.add (new TimerPanel ());
	}
	
	public Dimension getDimensioneSchermo ()		{ return dimensioneSchermo;	}
	public int getLarghezzaSchermo ()			{ return larghezzaSchermo;	}
	public int getAltezzaSchermo ()				{ return altezzaSchermo;	}
}

//Classe TimerPanel:
class TimerPanel extends JPanel implements ActionListener
{
	protected Timer timer;
	
	//Costruttore:
	public TimerPanel ()
	{
		super ();
		timer = new Timer (500, this);
		timer.start();
	}
	
	public void actionPerformed (ActionEvent a)
	{
		setBackground (new Color ((int)(255*Math.random()), (int)(255*Math.random()), (int)(255*Math.random())));
		repaint ();
	}
}
