// Test degli eventi relativi alle finestre:

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

//Classe pubblica TestWindowEvents:
public class TestWindowEvents extends Object
{
	//main:
	public static void main (String[] args)
	{
		//creazione del frame:
		JFrame frame = new TestWindowFrame ();
		
		//visualizzazione del frame:
		frame.show();
	}
}

//Classe TestWindowFrame:
class TestWindowFrame extends JFrame
{
	//variabili di istanza:
	private Dimension dimensioneSchermo;
	private int larghezzaSchermo, altezzaSchermo;
		
	//Costruttore:
	public TestWindowFrame ()
	{
		setTitle ("Test degli eventi relativi alle finestre");
		//setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		Toolkit tk = Toolkit.getDefaultToolkit ();
		dimensioneSchermo = tk.getScreenSize ();
		larghezzaSchermo = dimensioneSchermo.width;
		altezzaSchermo = dimensioneSchermo.height;
		
		setSize (larghezzaSchermo/2, altezzaSchermo/2);
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		
		Container cp = getContentPane();
		cp.add (new TestWindowPanel ());
		
		//aggiungo l'ascoltatore degli eventi relativi alle finestre:
		ListenerWindowEvents list = new ListenerWindowEvents ();
		addWindowListener (list);
	}
	
	//metodi di accesso alle variabili di istanza:
	public Dimension getDimensioneSchermo ()		{ return dimensioneSchermo;	}
	public int getLarghezzaSchermo ()			{ return larghezzaSchermo;	}
	public int getAltezzaSchermo ()				{ return altezzaSchermo;	}

}

//Classe ListenerWindowEvents:
class ListenerWindowEvents implements WindowListener
{
	//implementazione dei metodi dell'interfaccia WindowListener:
	public void windowOpened(WindowEvent e)
	{
		System.out.println ("La finestra  stata aperta");
	}
	
	public void windowClosing(WindowEvent e)
	{
		System.out.println ("La finestra si sta chiudendo");
		System.exit(1);		
	}
	
	public void windowClosed(WindowEvent e)
	{
		System.out.println ("La finestra  stata chiusa");
	}
	
	public void windowIconified(WindowEvent e)
	{
		System.out.println ("La finstra  stata iconizzata");
	}
	
	public void windowDeiconified(WindowEvent e)
	{
		System.out.println ("La finestra  stata deiconizzata");
	}
	
	public void windowActivated(WindowEvent e)
	{
		System.out.println ("La finestra  stata attivata");
	}
	
	public void windowDeactivated(WindowEvent e)
	{
		System.out.println ("La finestra  stata disattivata");
	}
}
	
//Classe TestWindowPanel:
class TestWindowPanel extends JPanel
{
	private Image myFoto;
	
	//Costruttore:
	public TestWindowPanel ()
	{
		super ();
		setBackground (Color.white);
		
		//ottengo l'immagine mediante il Toolkit:
		Toolkit tk = Toolkit.getDefaultToolkit();
		myFoto = tk.getImage ("/home/fabior/Documents/foto/sabrina.jpg");
		
		//carico l'immagine mediante il MediaTracker:
		MediaTracker tracker = new MediaTracker(this);
		tracker.addImage (myFoto, 0);
		
		//attendo che l'immagine sia caricata:
		try { tracker.waitForID (0); } catch (InterruptedException e) { return; }
	}

	//paintComponent():
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
		
		//disegno l'immagine:
		g.drawImage (myFoto, 20, 20, null);
		
		g.setColor (Color.blue);
		g.setFont (new Font ("Monospaced", Font.ITALIC+Font.BOLD, 40));
		g.drawString ("Sabrina Rinnone!", 60, 60);
	}
	
	//metodi di accesso alle variabili di istanza:
	public Image getMyFoto ()		{ return myFoto;	}
}