// TestMediaTrackerApp2.java:


import java.awt.*;
import javax.swing.*;

public class TestMediaTrackerApp2
{
	//main:
	public static void main (String[] args)
	{
		//creazione del frame:
		JFrame frame = new TestMediaTrackerFrame ();
		
		//visualizzazione del frame:
		frame.show();
	}
}

//Classe non pubblica che implementa il frame per l'applicazione:
class TestMediaTrackerFrame extends JFrame
{
	//variabili di istanza:
	private Dimension dimensioneSchermo;
	private int larghezzaSchermo, altezzaSchermo;
	
	private TestMediaTrackerPanel pannello;
	
	//Costruttore:
	public TestMediaTrackerFrame()
	{
		setTitle ("TestMediaTrackerApp2");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		//ottengo il Toolkit di default:
		Toolkit tk = Toolkit.getDefaultToolkit ();
		dimensioneSchermo = tk.getScreenSize ();
		larghezzaSchermo = dimensioneSchermo.width;
		altezzaSchermo = dimensioneSchermo.height;
		
		//setto le dimensioni del frame:
		setSize (larghezzaSchermo/2, altezzaSchermo/2);
		//setto la posizione del frame:
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		
		//creo un pannello:
		pannello = new TestMediaTrackerPanel ();
		
		//ottengo il contentPane:
		Container cp = getContentPane();
		
		//aggiungo i pannelli al contentPane:
		cp.add (pannello);
	}
}

//Classe non pubblica MioPannello:
class TestMediaTrackerPanel extends JPanel
{
	//variabile di istanza:
	private Image image;
		
	//Costruttore:
	public TestMediaTrackerPanel ()
	{
		super ();
		
		//creo un MediaTracker:
		MediaTracker tracker = new MediaTracker (new JPanel());
		
		//ottengo il Toolkit di default:
		Toolkit toolkit = Toolkit.getDefaultToolkit ();
		
		//ottengo un'immagine:
		image = toolkit.getImage ("monkey.jpg");
		
		//aggiungo l'immagine al MediaTracker:
		tracker.addImage (image, 0);
		
		//attendo il caricamento dell'immagine:
		try
		{
			tracker.waitForID (0);
		}
		catch (InterruptedException e)
		{
			System.out.println (e);
		}
	}
	
	//ridefinizione del metodo paintComponent():
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
		
		//disegno l'immagine caricata:
		g.drawImage (image, 0, 0, null);
	}
}
