/* Scheletro di una applicazione grafica standard */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;

public class MiaApplicazione
{
	//main:
	public static void main (String[] args)
	{
		//creazione del frame:
		JFrame frame = new MioFrame ();
		
		//visualizzazione del frame:
		frame.show();
	}
}

//Classe non pubblica che implementa il frame per l'applicazione:
class MioFrame extends JFrame implements ActionListener
{
	//variabili di istanza:
	private Dimension dimensioneSchermo;
	private int larghezzaSchermo, altezzaSchermo;
		
	private JMenuItem voceMenu1, voceMenu2;
	private MioPannello p1, p2;
	
	//Costruttore:
	public MioFrame ()
	{
		setTitle ("Titolo");
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		
		//ottengo il Toolkit di default:
		Toolkit tk = Toolkit.getDefaultToolkit ();
		dimensioneSchermo = tk.getScreenSize ();
		larghezzaSchermo = dimensioneSchermo.width;
		altezzaSchermo = dimensioneSchermo.height;
		
		//setto le dimensioni del frame:
		setSize (larghezzaSchermo/2, altezzaSchermo/2);
		//setto la posizione del frame:
		setLocation ((larghezzaSchermo-getSize().width)/2, (altezzaSchermo-getSize().height)/2);
		
		//creo la barra dei menu:
		JMenuBar barraMenu = new JMenuBar();
		//aggiungo la barra dei menu al frame:
		this.setJMenuBar (barraMenu);
		
		//creo i due menu:
		JMenu menu1 = new JMenu ("Menu 1");
		JMenu menu2 = new JMenu ("Menu 2");
		
		//aggiungo i due menu alla barra precedentemente creata:
		barraMenu.add (menu1);
		barraMenu.add (menu2);
		
		//creo tutti gli elementi di menu che sono necessari:
		voceMenu1 = new JMenuItem ("Voce Menu 1");
		voceMenu2 = new JMenuItem ("Voce Menu 2");
		
		//aggiungo gli elementi di menu ai menu:
		menu1.add (voceMenu1);
		menu2.add (voceMenu2);
		
		//scelgo il frame stesso come ascoltatore degli eventi generati dai menu:
		voceMenu1.addActionListener (this);
		voceMenu2.addActionListener (this);
		
		//ottengo il contentPane:
		Container cp = getContentPane ();
		
		//setto il layout del frame
		cp.setLayout (new GridLayout (1,2));
		
		//creo i due pannelli necessari:
		p1 = new MioPannello ();
		p2 = new MioPannello ();
		
		//aggiungo i pannelli al contentPane:
		cp.add (p1);
		cp.add (p2);
	}
	
	//definizione del metodo ActionPerformed dell'interfaccia ActionListener
	public void actionPerformed (ActionEvent e)
	{
		Object source = e.getSource();
	}
}

//Classe non pubblica MioPannello:
class MioPannello extends JPanel
{
	//Costruttore:
	public MioPannello ()
	{
		super ();
	}
	
	//ridefinizione del metodo paintComponent():
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
	}
}

