//Prova:

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.io.*;
import java.awt.image.*;
import javax.imageio.*;
import javax.swing.filechooser.FileFilter;

//Classe EsempioProvaApp:
public class ProvaApp
{
	//main:
	public static void main (String[] args)
	{
		//creazione del frame:
		JFrame f = new ProvaFrame ();
		
		//visualizzazione del frame:
		f.show();
	}
}

//Classe EsempioProvaFrame:
class ProvaFrame extends JFrame implements ActionListener
{
	//variabili di istanza:
	private ProvaPanel1 p1;
	private ProvaPanel2 p2;
	private JMenuItem inverti, rosso, giallo, carica, elabora;
	private JLabel label;
	private JFileChooser fileChooser;
	
	//Costruttore:
	public ProvaFrame ()
	{
		//testo nella barra del titolo:
		setTitle ("Titolo");
		//operazione di default di chiusura:
		setDefaultCloseOperation (EXIT_ON_CLOSE);
		//setto la locazione in cui verr visualizzato il frame:
		setLocation (20, 20);
		//setto la dimesione del frame:
		setSize (600, 480);
		
		//creo la barra dei menu:
		JMenuBar barraMenu = new JMenuBar();
		//aggiungo la barra dei menu al frame:
		this.setJMenuBar (barraMenu);
		
		//creo i due menu:
		JMenu menu1 = new JMenu ("Menu 1");
		JMenu menu2 = new JMenu ("Menu 2");
		
		//aggiungo i due menu alla barra precedentemente creata:
		barraMenu.add (menu1);
		barraMenu.add (menu2);
		
		//creo tutti gli elementi di menu che sono necessari:
		inverti = new JMenuItem ("Inverti");
		rosso = new JMenuItem ("Rosso");
		giallo = new JMenuItem ("Giallo");
		carica = new JMenuItem ("Carica immagine");
		elabora = new JMenuItem ("Elabora immagine");
		
		//aggiungo gli elementi di menu ai menu:
		menu1.add (inverti);
		menu1.add (rosso);
		menu1.add (giallo);
		menu2.add (carica);
		menu2.add (elabora);
		
		label = new JLabel ();		
		fileChooser = new JFileChooser ();
		//setto i filtri del JFileChooser:
		fileChooser.setAcceptAllFileFilterUsed (false);
		fileChooser.setFileFilter (new JPGFilter());
		fileChooser.setFileFilter (new PNGFilter());
		
		//scelgo il frame stesso come ascoltatore degli eventi generati dai menu:
		inverti.addActionListener (this);
		rosso.addActionListener (this);
		giallo.addActionListener (this);
		
		carica.addActionListener (new OpenListener (label, fileChooser));
		//elabora.addActionListener (new ElaboraImmagine ());
		
		//ottengo il contentPane:
		Container cp = getContentPane ();
		
		//setto il layout del frame
		cp.setLayout (new GridLayout (1,2));
		
		//creo i due pannelli necessari:
		p1 = new ProvaPanel1 ();
		p2 = new ProvaPanel2 ();
		
		//aggiungo i pannelli al contentPane:
		cp.add (p1);
		cp.add (p2);
		
		p1.add (label);
	}
	
	//implementazione del metodo ActionPerformed() dell'interfaccia ActionListener:
	public void actionPerformed (ActionEvent e)
	{
		Object source = e.getSource();
	}
}

//Classe EsempioProvaPanel1:
class ProvaPanel1 extends JPanel
{
	//variabili di istanza:
		
	//Costruttore:
	public ProvaPanel1 ()
	{
		super ();
	}
	
	//ridefinizione del metodo paintComponent (Graphics g):
	public void paintComponent (Graphics g)
	{
		super.paintComponent (g);
	}
}

//Classe EsempioProvaPanel2:
class ProvaPanel2 extends JPanel
{
	//Costruttore:
	public ProvaPanel2 ()
	{
	}
}

//Classe OpenListener:
class OpenListener implements ActionListener 
{
	//variabili di istanza:
	private JLabel label;
	private JFileChooser fileChooser;
		
	//Costruttore:
	public OpenListener (JLabel label, JFileChooser fileChooser)
	{
		this.label = label;
		this.fileChooser = fileChooser;
	}
	
	//definizione del metodo actionPerformed dell'interfaccia ActionListener:
	public void actionPerformed (ActionEvent e)
	{
		fileChooser.setDialogType (JFileChooser.OPEN_DIALOG);
		int risposta = fileChooser.showOpenDialog(label);
		
		//aggiungo il filtro per le immagini jpg:
		fileChooser.addChoosableFileFilter (new JPGFilter());
		
		if (risposta == fileChooser.APPROVE_OPTION) //Se ho premuto il tasto apri
		{
			//recupero il file selezionato
			File file = fileChooser.getSelectedFile();
			try
			{
				//provo ad aprire l'immagine
				Image image = ImageIO.read(file);
				
				//disegno l'immagine:
				label.setIcon (new ImageIcon (image));
			}
			catch (Exception ex)
			{
				System.out.println (e);
			}
		}
	}
}

//Classe JPGFilter:
class JPGFilter extends FileFilter
{
	//implemetazione dei metodi astratti della superclasse FileFilter
	public boolean accept (File f)
	{
		return f.getName().toLowerCase().endsWith (".jpg") || f.isDirectory();
	}
	
	public String getDescription ()
	{
		return "Immagine jpg";
	}
}

//Classe PNGFilter:
class PNGFilter extends FileFilter
{
	//implemetazione dei metodi astratti della superclasse FileFilter
	public boolean accept (File f)
	{
		return f.getName().toLowerCase().endsWith (".png") || f.isDirectory();
	}
	
	public String getDescription ()
	{
		return "Immagine png";
	}
}

