// Test della classe JFileChooser: (n2)

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.io.*;
import java.awt.image.*;
import javax.imageio.*;
import javax.swing.filechooser.FileFilter;

//Classe TestJFileChooserApp2:
public class TestJFileChooserApp2 extends Object
{
	//main:
	public static void main (String[] args)
	{
		JFrame frame = new JFrame ();
		JPanel panel = new JPanel ();
		JLabel label = new JLabel ();
		JMenuBar barraMenu = new JMenuBar ();
		JMenu file = new JMenu ("File");
		JMenuItem apri = new JMenuItem ("Apri");
		JMenuItem esci = new JMenuItem ("Esci");
		JFileChooser fileChooser = new JFileChooser();
		
		//setto i filtri del JFileChooser:
		fileChooser.setAcceptAllFileFilterUsed (false);
		fileChooser.setFileFilter (new JPGFilter());
		fileChooser.setFileFilter (new PNGFilter());
		
		frame.setTitle ("Esempio di apertura di un file");
		frame.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
		frame.setSize (1024, 702);
		
		frame.getContentPane().add (panel);
		frame.getContentPane().add (label);
		frame.setJMenuBar (barraMenu);
		barraMenu.add (file);
		file.add (apri);
		file.add (esci);
		
		apri.addActionListener (new OpenListener2 (label, fileChooser));
		esci.addActionListener (new EsciListener ());
		
		frame.show();
	}
}

//Classe OpenListener2:
class OpenListener2 implements ActionListener 
{
	//variabili di istanza:
	private JLabel label;
	private JFileChooser fileChooser;
		
	//Costruttore:
	public OpenListener2 (JLabel label, JFileChooser fileChooser)
	{
		this.label = label;
		this.fileChooser = fileChooser;
	}
	
	//definizione del metodo actionPerformed dell'interfaccia ActionListener:
	public void actionPerformed (ActionEvent e)
	{
		fileChooser.setDialogType (JFileChooser.OPEN_DIALOG);
		int risposta = fileChooser.showOpenDialog(label);
		
		//aggiungo il filtro per le immagini jpg:
		fileChooser.addChoosableFileFilter (new JPGFilter());
		
		if (risposta == fileChooser.APPROVE_OPTION) //Se ho premuto il tasto apri
		{
			//recupero il file selezionato
			File file = fileChooser.getSelectedFile();
			try
			{
				//provo ad aprire l'immagine
				Image image = ImageIO.read(file);
				
				//disegno l'immagine:
				label.setIcon (new ImageIcon (image));
			}
			catch (Exception ex)
			{
				System.out.println (e);
			}
		}
	}
}

//Classe EsciListener 
class EsciListener implements ActionListener
{
	public void actionPerformed (ActionEvent e)
	{
		System.exit(1);
	}
}

//Classe JPGFilter:
class JPGFilter extends FileFilter
{
	//implemetazione dei metodi astratti della superclasse FileFilter
	public boolean accept (File f)
	{
		return f.getName().toLowerCase().endsWith (".jpg") || f.isDirectory();
	}
	
	public String getDescription ()
	{
		return "Immagine jpg";
	}
}

//Classe PNGFilter:
class PNGFilter extends FileFilter
{
	//implemetazione dei metodi astratti della superclasse FileFilter
	public boolean accept (File f)
	{
		return f.getName().toLowerCase().endsWith (".png") || f.isDirectory();
	}
	
	public String getDescription ()
	{
		return "Immagine png";
	}
}


